# TODO:
# - c extension build is done in install phase (http://bugs.mysql.com/bug.php?id=78621)
#
# Conditional build:
%bcond_with	tests		# build with tests (requires mysql server)
%bcond_without	python2		# build without python2
%bcond_without	python3		# build without python3

%define		pname	mysql-connector
Summary:	The MySQL Client/Protocol implemented in Python
Summary(pl.UTF-8):	Protokół kliencki MySQL zaimplementowany w Pythonie
Name:		python-%{pname}
# check documentation to see which version is GA (we don't want devel releases)
# https://dev.mysql.com/downloads/connector/python/
Version:	8.0.23
Release:	2
License:	GPL v2
Group:		Libraries/Python
# Source0:	http://cdn.mysql.com/Downloads/Connector-Python/mysql-connector-python-%{version}-src.tar.gz
Source0:	https://pypi.debian.net/mysql-connector-python/mysql-connector-python-%{version}.tar.gz
# Source0-md5:	798f57c5e577a34787342821a0cb3a87
Patch0:		force-capi.patch
Patch1:		tests.patch
Patch2:		build.patch
Patch3:		py10.patch
URL:		http://dev.mysql.com/doc/connector-python/en/
BuildRequires:	mysql-devel
BuildRequires:	protobuf-devel >= 3.0.0
%if %{with python2}
BuildRequires:	python-devel
BuildRequires:	python-modules
BuildRequires:	python-setuptools
%endif
%if %{with python3}
BuildRequires:	python3-devel
BuildRequires:	python3-modules
BuildRequires:	python3-setuptools
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with tests}
BuildRequires:	mysql
%endif
Requires:	python-modules
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
MySQL Connector/Python is implementing the MySQL Client/Server
protocol completely in Python. No MySQL libraries are needed, and no
compilation is necessary to run this Python DB API v2.0 compliant
driver.

%description -l pl.UTF-8
MySQL Connector/Python to protokół klient-serwer MySQL-a
zaimplementowany całkowicie w Pythonie. Do uruchomienia tego
sterownika, zgodnego z DB API v2.0 Pythona, nie są potrzebne
biblioteki MySQL-a, ani żadna kompilacja.

%package -n python3-%{pname}
Summary:	The MySQL Client/Protocol implemented in Python
Summary(pl.UTF-8):	Protokół kliencki MySQL zaimplementowany w Pythonie
Group:		Development/Languages/Python
Requires:	python3-modules

%description -n python3-%{pname}
MySQL Connector/Python is implementing the MySQL Client/Server
protocol completely in Python. No MySQL libraries are needed, and no
compilation is necessary to run this Python DB API v2.0 compliant
driver.

%description -n python3-%{pname} -l pl.UTF-8
MySQL Connector/Python to protokół klient-serwer MySQL-a
zaimplementowany całkowicie w Pythonie. Do uruchomienia tego
sterownika, zgodnego z DB API v2.0 Pythona, nie są potrzebne
biblioteki MySQL-a, ani żadna kompilacja.

%prep
%setup -q -n mysql-connector-python-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
export MYSQLXPB_PROTOC=%{_bindir}/protoc
export MYSQLXPB_PROTOBUF_INCLUDE_DIR=%{_includedir}
export MYSQLXPB_PROTOBUF_LIB_DIR=%{_libdir}

%if %{with python2}
%py_build
%if %{with tests}
export PYTHONPATH="$(pwd)/$(echo build-2/lib*)"
%{__python} unittests.py \
	--verbosity 1 \
	--keep --stats \
	--skip-install \
	--with-mysql=%{_prefix} \
	--with-mysql-share=%{_datadir}/mysql
%endif
%endif

%if %{with python3}
%py3_build
%if %{with tests}
export PYTHONPATH="$(pwd)/$(echo build-3/lib*)"
%{__python3} unittests.py \
	--verbosity 1 \
	--keep --stats \
	--skip-install \
	--with-mysql=%{_prefix} \
	--with-mysql-share=%{_datadir}/mysql
%endif
%endif

%install
rm -rf $RPM_BUILD_ROOT

# see NOTE on beginning of the spec
export MYSQLXPB_PROTOC=%{_bindir}/protoc
export MYSQLXPB_PROTOBUF_INCLUDE_DIR=%{_includedir}
export MYSQLXPB_PROTOBUF_LIB_DIR=%{_libdir}

%if %{with python2}
%py_install \
	--with-mysql-capi=%{_prefix}
%py_postclean
%endif

%if %{with python3}
%py3_install \
	--with-mysql-capi=%{_prefix}
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CHANGES.txt README.txt
%attr(755,root,root) %{py_sitedir}/_mysql_connector.so
%dir %{py_sitedir}/mysql
%{py_sitedir}/mysql/*.py[co]
%dir %{py_sitedir}/mysql/connector
%{py_sitedir}/mysql/connector/*.py[co]
%dir %{py_sitedir}/mysql/connector/django
%{py_sitedir}/mysql/connector/django/*.py[co]
%dir %{py_sitedir}/mysql/connector/locales
%{py_sitedir}/mysql/connector/locales/*.py[co]
%dir %{py_sitedir}/mysql/connector/locales/eng
%{py_sitedir}/mysql/connector/locales/eng/*.py[co]
%dir %{py_sitedir}/mysqlx
%{py_sitedir}/mysqlx/*.py[co]
%dir %{py_sitedir}/mysqlx/protobuf
%{py_sitedir}/mysqlx/protobuf/*.py[co]
%dir %{py_sitedir}/mysqlx/locales
%{py_sitedir}/mysqlx/locales/*.py[co]
%dir %{py_sitedir}/mysqlx/locales/eng
%{py_sitedir}/mysqlx/locales/eng/*.py[co]
%if "%{py_ver}" > "2.4"
%{py_sitedir}/mysql_connector_python-*.egg-info
%endif
%endif

%if %{with python3}
%files -n python3-%{pname}
%defattr(644,root,root,755)
%doc CHANGES.txt README.txt
%attr(755,root,root) %{py3_sitedir}/_mysql_connector.cpython-*.so
%{py3_sitedir}/mysql*.egg-info
%dir %{py3_sitedir}/mysql
%{py3_sitedir}/mysql/*.py
%dir %{py3_sitedir}/mysql/__pycache__
%{py3_sitedir}/mysql/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysql/connector
%{py3_sitedir}/mysql/connector/*.py
%dir %{py3_sitedir}/mysql/connector/__pycache__
%{py3_sitedir}/mysql/connector/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysql/connector/django
%{py3_sitedir}/mysql/connector/django/*.py
%dir %{py3_sitedir}/mysql/connector/django/__pycache__
%{py3_sitedir}/mysql/connector/django/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysql/connector/locales
%{py3_sitedir}/mysql/connector/locales/*.py
%dir %{py3_sitedir}/mysql/connector/locales/__pycache__
%{py3_sitedir}/mysql/connector/locales/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysql/connector/locales/eng
%{py3_sitedir}/mysql/connector/locales/eng/*.py
%dir %{py3_sitedir}/mysql/connector/locales/eng/__pycache__
%{py3_sitedir}/mysql/connector/locales/eng/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysqlx
%{py3_sitedir}/mysqlx/*.py
%dir %{py3_sitedir}/mysqlx/__pycache__
%{py3_sitedir}/mysqlx/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysqlx/locales
%{py3_sitedir}/mysqlx/locales/*.py
%dir %{py3_sitedir}/mysqlx/locales/__pycache__
%{py3_sitedir}/mysqlx/locales/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysqlx/locales/eng
%{py3_sitedir}/mysqlx/locales/eng/*.py
%dir %{py3_sitedir}/mysqlx/locales/eng/__pycache__
%{py3_sitedir}/mysqlx/locales/eng/__pycache__/*.py[co]
%dir %{py3_sitedir}/mysqlx/protobuf
%{py3_sitedir}/mysqlx/protobuf/*.py
%dir %{py3_sitedir}/mysqlx/protobuf/__pycache__
%{py3_sitedir}/mysqlx/protobuf/__pycache__/*.py[co]
%endif
%changelog
* Thu Apr 28 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-mysql-connector.git;a=log;h=master

* Thu Apr 28 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 4933877
- Rel 2; python 3.10 support

* Thu Apr 28 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> c42c644
- Up to 8.0.23; force capi extension build

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> e33ec80
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 5bd4f18
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> ff86485
- rebuild with python 3.10

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> d2adaf5
- rebuild with separate debuginfo build-ids

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> 122f284
- release 2 (by relup.sh)

* Mon Jul 13 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> bcab3f0
- up to 8.0.21

* Mon Apr 27 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 4d0627c
- up to 8.0.20

* Fri Jan 17 2020 Jan Rękorajski <baggins@pld-linux.org> a80a3e8
- relax python-protobuf deps

* Thu Jan 16 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> b369dad
- up to 8.0.19

* Mon Oct 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 93ddb4c
- pl, BR: python-setuptools

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 671c66b
- rebuild with python 3.8
- release 2 (by relup.sh)

* Tue Oct 15 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 7b715bf
- up to 8.0.18

* Fri Apr 26 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 8d51039
- up to 8.0.16

* Fri Feb 22 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 96cbe55
- up to 8.0.15

* Tue Nov 27 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 96b9f6f
- rel 2; binary patch seems no longer needed

* Thu Nov 08 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1859850
- up to 8.0.13

* Sat Jul 28 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 0ca036a
- up to 8.0.12

* Mon Jul 02 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> cbc65c7
- release 4 (by relup.sh)

